## blasr 0~20150724+git3ca7fe8

=== Makefile ===
SHELL=bash -e -E

.PHONY: all pblib makeutils gtest cramtests cramfast check clean cleanall cleanlib

include common.mk

SRCS := $(wildcard *.cpp)
OBJS := $(SRCS:.cpp=.o)
DEPS := $(SRCS:.cpp=.d)
EXE = blasr
UTILS = utils

all : CXXFLAGS ?= $(DEFAULTCXXFLAG)
debug : CXXFLAGS ?= $(DEBUGCXXFLAG)
profile : CXXFLAGS ?= $(PROFILECXXFLAG)
g: CXXFLAGS += $(GCXXFLAG)
g: LIBS = $(GLIBS)


all debug profile g: $(EXE) makeutils 

$(EXE): $(SRCS) $(PBLIB)
	$(CXX) $(CXXOPTS) $(CXXFLAGS) $(INCDIRS) -MF"$(@:%=%.d)" $(STATIC) -o $@ $(SRCS) $(LIBDIRS) $(LIBS)

# DON'T use pbbam which is not on github.
PBINCROOT:=$(abspath libcpp)
pblib: $(PBINCROOT)/configure.py $(PBINCROOT)/makefile
	cd $(PBINCROOT) && NOPBBAM=true HDF5_LIB=${HDF5_LIB}/libhdf5.so ./configure.py
	cd $(PBINCROOT) && ${MAKE}

makeutils:
	make -C $(UTILS) $(MODE) 

CTESTS := $(wildcard ctest/*.t)
SLOW_CTESTS := ctest/bug25328.t ctest/useccsallLargeGenome.t

cramtests: $(EXE) $(UTILS) 
	cram -v --shell=/bin/bash $(CTESTS)
	make -C $(UTILS) cramtests

cramfast: $(EXE) $(UTILS)
	cram -v --shell=/bin/bash $(filter-out $(SLOW_CTESTS),$(CTESTS))
	make -C $(UTILS) cramfast

gtest: $(EXE)
	make -C $(PBINCROOT) gtest

check: gtest cramtests

cleanall: cleanlib clean

cleanlib: $(PBINCROOT)/Makefile
	@make -C $(PBINCROOT) cleanall

clean: 
	@rm -f $(EXE) $(OBJS) $(DEPS) blasr.d
	@make -C $(UTILS) clean

-include $(DEPS)

=== extrautils/Makefile ===
SHELL=/bin/bash -e -E

.PHONY=all cramtests

PBINCROOT ?= $(realpath ../../../lib/cpp/)
PREBUILT ?= $(realpath ../../../../prebuilt.out)
THIRD_PARTY_PREFIX := $(realpath ../..)

include ../common.mk

all : CXXFLAGS ?= $(DEFAULTCXXFLAG)

debug : CXXFLAGS ?= $(DEBUGCXXFLAG)

profile : CXXFLAGS ?= $(PROFILECXXFLAG)

g: CXXFLAGS += $(GCXXFLAG)
g: LIBS = $(GLIBS)

exe = sa2bwt bwt2sa alchemy excrep evolve bsdb simpleShredder swMatcher \
  samodify sals printTupleCountTable cmpH5StoreQualityByContext ccsh5tobam

all debug profile g: $(exe)

sa2bwt: SuffixArrayToBWT.cpp $(PBLIB)
	$(CXX) $(CXXOPTS) $(CXXFLAGS) $(INCDIRS) -MF"$(@:%=%.d)" $(STATIC) -o $@ $< $(LIBDIRS) $(LIBS)

bwt2sa: BwtToSuffixArray.cpp $(PBLIB)
	$(CXX) $(CXXOPTS) $(CXXFLAGS) $(INCDIRS) -MF"$(@:%=%.d)" $(STATIC) -o $@ $< $(LIBDIRS) $(LIBS)

alchemy: BasH5Simulator.cpp $(PBLIB)
	$(CXX) $(CXXOPTS) $(CXXFLAGS) $(INCDIRS) -MF"$(@:%=%.d)" $(STATIC) -o $@ $< $(LIBDIRS) $(LIBS)

excrep: ExciseRepeats.cpp $(PBLIB)
	$(CXX) $(CXXOPTS) $(CXXFLAGS) $(INCDIRS) -MF"$(@:%=%.d)" $(STATIC) -o $@ $< $(LIBDIRS) $(LIBS)

evolve: Evolve.cpp $(PBLIB)
	$(CXX) $(CXXOPTS) $(CXXFLAGS) $(INCDIRS) -MF"$(@:%=%.d)" $(STATIC) -o $@ $< $(LIBDIRS) $(LIBS)

bsdb: BuildSequenceDB.cpp $(PBLIB)
	$(CXX) $(CXXOPTS) $(CXXFLAGS) $(INCDIRS) -MF"$(@:%=%.d)" $(STATIC) -o $@ $< $(LIBDIRS) $(LIBS)

simpleShredder: SimpleShredder.cpp $(PBLIB)
	$(CXX) $(CXXOPTS) $(CXXFLAGS) $(INCDIRS) -MF"$(@:%=%.d)" $(STATIC) -o $@ $< $(LIBDIRS) $(LIBS)

swMatcher: SWMatcher.cpp $(PBLIB)
	$(CXX) $(CXXOPTS) $(CXXFLAGS) $(INCDIRS) -MF"$(@:%=%.d)" $(STATIC) -o $@ $< $(LIBDIRS) $(LIBS)

samodify: SAModify.cpp $(PBLIB)
	$(CXX) $(CXXOPTS) $(CXXFLAGS) $(INCDIRS) -MF"$(@:%=%.d)" $(STATIC) -o $@ $< $(LIBDIRS) $(LIBS)

sals: SALS.cpp $(PBLIB)
	$(CXX) $(CXXOPTS) $(CXXFLAGS) $(INCDIRS) -MF"$(@:%=%.d)" $(STATIC) -o $@ $< $(LIBDIRS) $(LIBS)

printTupleCountTable: PrintTupleCountTable.cpp $(PBLIB)
	$(CXX) $(CXXOPTS) $(CXXFLAGS) $(INCDIRS) -MF"$(@:%=%.d)" $(STATIC) -o $@ $< $(LIBDIRS) $(LIBS)

cmpH5StoreQualityByContext: StoreQualityByContextFromCmpH5.cpp $(PBLIB)
	$(CXX) $(CXXOPTS) $(CXXFLAGS) $(INCDIRS) -MF"$(@:%=%.d)" $(STATIC) -o $@ $< $(LIBDIRS) $(LIBS)

ccsh5tobam: CCSH5ToBam.cpp $(PBLIB)
	$(CXX) $(CXXOPTS) $(CXXFLAGS) $(INCDIRS) -MF"$(@:%=%.d)" $(STATIC) -o $@ $< $(LIBDIRS) $(LIBS)

pblib: $(PBINCROOT)/Makefile
	make -C $(PBINCROOT)

.INTERMEDIATE: $(OBJS)

CTESTS = $(wildcard ctest/*.t)
cramtests: $(EXE)
	cram --shell=/bin/bash $(CTESTS)

clean: 
	@rm -f $(exe)
	@rm -f $(OBJS) $(DEPS)
	@rm *.o *.d

-include $(DEPS)

=== utils/Makefile ===
SHELL=/bin/bash -e -E

.PHONY=all cramtests

PBINCROOT ?= $(realpath ../../../lib/cpp/)
PREBUILT ?= $(realpath ../../../../prebuilt.out)
THIRD_PARTY_PREFIX := $(realpath ../..)

include ../common.mk

all : CXXFLAGS ?= $(DEFAULTCXXFLAG)

debug : CXXFLAGS ?= $(DEBUGCXXFLAG)

profile : CXXFLAGS ?= $(PROFILECXXFLAG)

g: CXXFLAGS += $(GCXXFLAG)
g: LIBS = $(GLIBS)

EXE = loadPulses pls2fasta samtoh5 samtom4 samFilter toAfg sawriter sdpMatcher

all debug profile g: $(EXE)

loadPulses: LoadPulses.cpp $(PBLIB)
	$(CXX) $(CXXOPTS) $(CXXFLAGS) $(INCDIRS) -MF"$(@:%=%.d)" $(STATIC) -o $@ $< $(LIBDIRS) $(LIBS)

pls2fasta: PulseToFasta.cpp $(PBLIB)
	$(CXX) $(CXXOPTS) $(CXXFLAGS) $(INCDIRS) -MF"$(@:%=%.d)" $(STATIC) -o $@ $< $(LIBDIRS) $(LIBS)

samtoh5: SamToCmpH5.cpp $(PBLIB)
	$(CXX) $(CXXOPTS) $(CXXFLAGS) $(INCDIRS) -MF"$(@:%=%.d)" $(STATIC) -o $@ $< $(LIBDIRS) $(LIBS)

samtom4: SamToM4.cpp $(PBLIB)
	$(CXX) $(CXXOPTS) $(CXXFLAGS) $(INCDIRS) -MF"$(@:%=%.d)" $(STATIC) -o $@ $< $(LIBDIRS) $(LIBS)

samFilter: SamFilter.cpp $(PBLIB)
	$(CXX) $(CXXOPTS) $(CXXFLAGS) $(INCDIRS) -MF"$(@:%=%.d)" $(STATIC) -o $@ $< $(LIBDIRS) $(LIBS)

toAfg: ToAfg.cpp $(PBLIB)
	$(CXX) $(CXXOPTS) $(CXXFLAGS) $(INCDIRS) -MF"$(@:%=%.d)" $(STATIC) -o $@ $< $(LIBDIRS) $(LIBS)

sawriter: SAWriter.cpp $(PBLIB)
	$(CXX) $(CXXOPTS) $(CXXFLAGS) $(INCDIRS) -MF"$(@:%=%.d)" $(STATIC) -o $@ $< $(LIBDIRS) $(LIBS)

sdpMatcher: SDPMatcher.cpp $(PBLIB)
	$(CXX) $(CXXOPTS) $(CXXFLAGS) $(INCDIRS) -MF"$(@:%=%.d)" $(STATIC) -o $@ $< $(LIBDIRS) $(LIBS)

pblib: $(PBINCROOT)/Makefile
	make -C $(PBINCROOT)

CTESTS := $(wildcard ctest/*.t)
SLOW_CTESTS := ctest/loadPulses.t ctest/pls2fasta.t

cramtests: $(EXE)
	cram -v --shell=/bin/bash $(CTESTS)

cramfast: $(EXE)
	cram -v --shell=/bin/bash $(filter-out $(SLOW_CTESTS), $(CTESTS))

clean: 
	@rm -f $(EXE)
	@rm -f *.d *.o

-include $(DEPS)

=== libcpp/unittest/Makefile ===
SHELL=bash

V  := 0
V@ := @
ifeq ($(V),$(filter $(V),1))
    # Enable verbose mode if V=1 or V= specified on command ine
    V@ :=
endif

MKDIR := mkdir

null :=
space := $(null) $(null)



OUTDIR := _output

GTEST_SRCDIR       := __UNSET__

LIBBLASR_INCLUDE   := __UNSET__
LIBPBIHDF_INCLUDE  := __UNSET__
LIBPBDATA_INCLUDE  := __UNSET__
PBBAM_INCLUDE      := __UNSET__
HTSLIB_INCLUDE     := __UNSET__
HDF5_INCLUDE       := __UNSET__
BOOST_INCLUDE      := __UNSET__
GTEST_INCLUDE      := __UNSET__

LIBBLASR_LIB       := __UNSET__
LIBPBIHDF_LIB      := __UNSET__
LIBPBDATA_LIB      := __UNSET__
PBBAM_LIB          := __UNSET__
HTSLIB_LIB         := __UNSET__
HDF5_LIB           := __UNSET__
ZLIB_LIB           := __UNSET__



broken_test_sources := \
	alignment/files/ReaderAgglomerate_gtest.cpp \
	alignment/format/SAMHeaderPrinter_gtest.cpp \
	alignment/format/SAMPrinter_gtest.cpp \
	alignment/utils/FileUtils_gtest.cpp \
	$(null)


gtest_sources  := $(GTEST_SRCDIR)/gtest/gtest-all.cc \
                  $(GTEST_SRCDIR)/gtest/gtest_main.cc \
		  $(null)

test_sources   := $(wildcard pbdata/*.cpp) \
                  $(wildcard pbdata/utils/*.cpp) \
                  $(wildcard pbdata/metagenome/*.cpp) \
                  $(wildcard pbdata/saf/*.cpp) \
                  $(wildcard pbdata/reads/*.cpp) \
                  $(wildcard pbdata/qvs/*.cpp)  \
                  \
                  $(wildcard hdf/*.cpp) \
                  \
                  $(wildcard alignment/*.cpp) \
                  $(wildcard alignment/utils/*.cpp) \
                  $(wildcard alignment/datastructures/alignment/*.cpp) \
                  $(wildcard alignment/files/*.cpp) \
                  $(wildcard alignment/format/*.cpp) \
                  $(null)

# Remove broken tests from the test_sources list
test_sources   := $(filter-out $(broken_test_sources),$(test_sources))


sources   := $(gtest_sources) $(test_sources)
objects   := $(patsubst %.cc,$(OUTDIR)/%.o,$(filter %.cc,$(sources))) \
             $(patsubst %.cpp,$(OUTDIR)/%.o,$(filter %.cpp,$(sources))) \
             $(null)
depfiles  := $(objects:%.o=%.d)


includes := \
    -I. \
    -I$(GTEST_INCLUDE) \
    -I$(LIBBLASR_INCLUDE) \
    -I$(LIBPBIHDF_INCLUDE) \
    -I$(LIBPBDATA_INCLUDE) \
    -I$(PBBAM_INCLUDE) \
    -I$(HTSLIB_INCLUDE) \
    -I$(HDF5_INCLUDE) \
    -I$(BOOST_INCLUDE) \
    $(null)

libs := \
    $(LIBBLASR_LIB) \
    $(LIBPBIHDF_LIB) \
    $(LIBPBDATA_LIB) \
    $(PBBAM_LIB) \
    $(HTSLIB_LIB) \
    $(HDF5_LIB) \
    $(HDF5_CPP_LIB) \
    $(ZLIB_LIB) \
    $(null)


sys_ldflags := -lpthread -ldl -lrt


cxxopts := -std=c++11 -Wno-div-by-zero 
cxxflags := -O3
ldflags := $(libs) $(sys_ldflags)



CPPFLAGS := $(includes) $(EXTRA_CPPFLAGS)
CXXFLAGS := $(cxxflags) $(cxxopts) $(EXTRA_CXXFLAGS)
LDLIBS   := $(ldflags) $(EXTRA_LDLIBS)

OUTPUT_OPTION = -o $@
COMPILE.cpp   = $(CXX) $(CXXFLAGS) $(CPPFLAGS) $(TARGET_ARCH) -c
COMPILE.cc    = $(COMPILE.cpp)
LINK.o        = $(CXX) $(LDFLAGS) $(TARGET_ARCH)


all: test-runner

test-runner: $(objects)
	$(V@)$(LINK.o) $^ $(LDLIBS) $(OUTPUT_OPTION)

gtest: test-runner
	$(V@)LD_LIBRARY_PATH=$(subst $(space),:,$(strip $(dir $(libs)))) ./$< --gtest_output=xml:$(OUTDIR)/xml/all.xml

# Build objects
$(OUTDIR)/%.o: %.cpp
	@echo "  CXX    $@"
	$(V@)$(COMPILE.cpp) $(OUTPUT_OPTION) $<

$(OUTDIR)/%.o: %.cc
	@echo "  CXX    $@"
	$(V@)$(COMPILE.cc) $(OUTPUT_OPTION) $<

# Make all directories of object files 'order-only' dependencies of all objects
# This will make all the output directories we need before building any objects
$(objects): | $(dir $(objects))

# Create any output directories
$(OUTDIR)/%/:
	$(V@)$(MKDIR) -p "$@"


clean:
	$(V@)$(RM) -r $(OUTDIR)

-include ($DEPS)

=== debian/changelog ===
blasr (0~20150724+git3ca7fe8-1~bpo8+1) jessie-backports; urgency=medium

  * Rebuild for jessie-backports.

 -- Afif Elghraoui <afif@ghraoui.name>  Sun, 06 Sep 2015 02:20:55 -0700

blasr (0~20150724+git3ca7fe8-1) unstable; urgency=low

  * Initial release (Closes: #793763)
  * Statically link native libraries and dynamically link external ones
  * Create manpages

 -- Afif Elghraoui <afif@ghraoui.name>  Sun, 26 Jul 2015 22:19:06 -0700

=== debian/control ===
Source: blasr
Section: science
Priority: optional
Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders: Afif Elghraoui <afif@ghraoui.name>
Build-Depends: debhelper (>= 9),
	       python,
	       libhdf5-dev,
	       zlib1g-dev
Standards-Version: 3.9.6
Homepage: https://github.com/PacificBiosciences/blasr
Vcs-Git: git://anonscm.debian.org/debian-med/blasr.git
Vcs-Browser: http://anonscm.debian.org/cgit/debian-med/blasr.git

Package: blasr
Architecture: any
Depends: ${shlibs:Depends},
	 ${misc:Depends}
Description: mapping single-molecule sequencing reads
 Basic local alignment with successive refinement (BLASR) is a method
 for mapping single-molecule sequencing reads against a reference genome.
 Such reads are thousands of bases long, with divergence between them
 and the genome being dominated by insertion and deletion error.

=== debian/rules ===
#!/usr/bin/make -f

DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/default.mk

export HDF5_INC=/usr/include/hdf5/serial
export HDF5_LIB=/usr/lib/$(DEB_HOST_MULTIARCH)/hdf5/serial

# This is needed for libcpp/configure.py. The top-level configure.py
# uses a command-line argument.
export NOPBBAM=1

%:
	dh $@ 

override_dh_auto_configure:
	./configure.py --no-pbbam --submodules
	libcpp/configure.py

override_dh_auto_build:
	$(MAKE) build-submodule
	$(MAKE)

# Tests require cram. I don't find it available in Debian
override_dh_auto_test:

override_dh_auto_clean: override_dh_auto_configure
	$(MAKE) cleanall
	# This is created by configure.py
	rm -f defines.mk
	# These are created by libcpp/configure.py
	rm -f libcpp/defines.mk libcpp/pbdata/libconfig.h

## blasr 0~20151014+git8e668be

=== debian/changelog ===
blasr (0~20151014+git8e668be-1) unstable; urgency=high

  * Don't install LICENSES.txt file
  * Imported Upstream version 0~20151014+git8e668be
  * Use externally packaged pbseqlib and dynamically link to it
    (Closes: #807985)
  * Adjust for renamed upstream documentation
  * Minor clean-ups
  * Update comment about why tests can't be run
  * Allow building in parallel

 -- Afif Elghraoui <afif@ghraoui.name>  Mon, 14 Dec 2015 19:51:57 -0800

=== debian/control ===
--- 
+++ 
@@ -3,10 +3,14 @@
 Priority: optional
 Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
 Uploaders: Afif Elghraoui <afif@ghraoui.name>
-Build-Depends: debhelper (>= 9),
-	       python,
-	       libhdf5-dev,
-	       zlib1g-dev
+Build-Depends:
+	debhelper (>= 9),
+	python,
+	libhdf5-dev,
+	zlib1g-dev,
+	libblasr-dev,
+	libpbdata-dev,
+	libpbihdf-dev,
 Standards-Version: 3.9.6
 Homepage: https://github.com/PacificBiosciences/blasr
 Vcs-Git: git://anonscm.debian.org/debian-med/blasr.git
@@ -14,8 +18,12 @@
 
 Package: blasr
 Architecture: any
-Depends: ${shlibs:Depends},
-	 ${misc:Depends}
+Depends:
+	${shlibs:Depends},
+	${misc:Depends},
+	libblasr,
+	libpbdata,
+	libpbihdf,
 Description: mapping single-molecule sequencing reads
  Basic local alignment with successive refinement (BLASR) is a method
  for mapping single-molecule sequencing reads against a reference genome.

=== debian/rules ===
#!/usr/bin/make -f

DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/default.mk

export HDF5_INC=/usr/include/hdf5/serial
export HDF5_LIB=/usr/lib/$(DEB_HOST_MULTIARCH)/hdf5/serial

export LIBBLASR_INC=/usr/include/blasr
export LIBBLASR_LIB=/usr/lib/$(DEB_HOST_MULTIARCH)/blasr
export LIBPBDATA_INC=/usr/include/pbdata
export LIBPBDATA_LIB=/usr/lib/$(DEB_HOST_MULTIARCH)/pbdata
export LIBPBIHDF_INC=/usr/include/pbihdf
export LIBPBIHDF_LIB=/usr/lib/$(DEB_HOST_MULTIARCH)/pbihdf

export LD_RUN_PATH=$(LIBBLASR_LIB):$(LIBPBDATA_LIB):$(LIBPBIHDF_LIB)

%:
	dh $@ --parallel

override_dh_auto_configure:
	./configure.py --no-pbbam --shared

# Tests require data not available in the source distribution
override_dh_auto_test:

override_dh_auto_clean: override_dh_auto_configure
	$(MAKE) clean
	# This is created by configure.py
	$(RM) defines.mk

## blasr 5.3

=== utils/bam2bax/CMakeLists.txt ===
########################################################################
# CMake build script for Bam2Bax executable.
########################################################################

project(Bam2Bax CXX C)
cmake_minimum_required(VERSION 2.8)

# project version
set(Bam2Bax_MAJOR_VERSION 0)
set(Bam2Bax_MINOR_VERSION 0)
set(Bam2Bax_PATCH_VERSION 1)
set(Bam2Bax_VERSION
  "${Bam2Bax_MAJOR_VERSION}.${Bam2Bax_MINOR_VERSION}.${Bam2Bax_PATCH_VERSION}"
)

# build-time options
option(Bam2Bax_build_tests "Build Bam2Bax's unit tests." ON)

# main project paths
set(Bam2Bax_RootDir       ${Bam2Bax_SOURCE_DIR})
set(Bam2Bax_DocsDir       ${Bam2Bax_RootDir}/docs)
set(Bam2Bax_SourceDir     ${Bam2Bax_RootDir}/src)
set(Bam2Bax_TestsDir      ${Bam2Bax_RootDir}/tests)
set(Bam2Bax_ThirdPartyDir ${Bam2Bax_RootDir}/third-party)

if (NOT Bam2Bax_OutputDir)
    set(Bam2Bax_OutputDir ${Bam2Bax_RootDir})
endif()

set(Bam2Bax_BinDir        ${Bam2Bax_OutputDir}/bin)
file(MAKE_DIRECTORY       ${Bam2Bax_BinDir})

# shared & third-party paths

if (NOT PBDATA_ROOT_DIR)
    set(PBDATA_ROOT_DIR ${Bam2Bax_RootDir}/../../../blasr_libcpp)
endif()

# find (existing) libraries needed by executable and tests
if (NOT BLASR_INCLUDE_DIRS OR NOT BLASR_LIBRARIES)
    find_library(BLASR_LIBRARIES    blasr    ${PBDATA_ROOT_DIR}/alignment)
    set(BLASR_INCLUDE_DIRS ${PBDATA_ROOT_DIR}/alignment)
endif()

if (NOT PBIHDF_INCLUDE_DIRS OR NOT PBIHDF_LIBRARIES)
    find_library(PBIHDF_LIBRARIES   pbihdf   ${PBDATA_ROOT_DIR}/hdf)
    set(PBIHDF_INCLUDE_DIRS ${PBDATA_ROOT_DIR}/hdf)
endif()

if (NOT PBDATA_INCLUDE_DIRS OR NOT PBDATA_LIBRARIES)
    find_library(PBDATA_LIBRARIES   pbdata   ${PBDATA_ROOT_DIR}/pbdata)
    set(PBDATA_INCLUDE_DIRS ${PBDATA_ROOT_DIR}/pbdata)
endif()

if (NOT HDF5_INCLUDE_DIRS OR NOT HDF5_LIBRARIES)
    if (NOT HDF5_RootDir)
        set(HDF5_RootDir ${Bam2Bax_RootDir}/../../../../../../prebuilt.out/hdf5/hdf5-1.8.12/ubuntu-1404)
    endif()

    set(HDF5_INCLUDE_DIRS ${HDF5_RootDir}/include)
    set(HDF5_LibDir       ${HDF5_RootDir}/lib)

    find_library(HDF5_LIBRARIES     hdf5     ${HDF5_LibDir} NO_CMAKE_SYSTEM_PATH)
    find_library(HDF5_CPP_LIBRARIES hdf5_cpp ${HDF5_LibDir} NO_CMAKE_SYSTEM_PATH)
endif()

if (NOT PacBioBAM_INCLUDE_DIRS OR NOT PacBioBAM_LIBRARIES
    OR NOT HTSLIB_INCLUDE_DIRS OR NOT HTSLIB_LIBRARIES)
    set(PacBioBAM_RootDir ${Bam2Bax_RootDir}/../../../../../lib/cpp/pbbam)
    add_subdirectory(${PacBioBAM_RootDir} external/build/pbbam)
endif()

if (NOT Boost_INCLUDE_DIRS)
    find_package(Boost REQUIRED)
endif()

if (NOT ZLIB_LIBRARIES OR NOT ZLIB_INCLUDE_DIRS)
    find_package(ZLIB REQUIRED)
endif()

# shared CXX flags for src & tests
include(CheckCXXCompilerFlag)
set(Bam2Bax_CXX_FLAGS "-g -std=c++11 -Wall")

# quash warnings from pbdata
check_cxx_compiler_flag("-Wno-overloaded-virtual" HAS_NO_OVERLOADED_VIRTUAL)
if(HAS_NO_OVERLOADED_VIRTUAL)
    set(Bam2Bax_CXX_FLAGS "${Bam2Bax_CXX_FLAGS} -Wno-overloaded-virtual")
endif()
#check_cxx_compiler_flag("-Wno-unused-private-field" HAS_NO_UNUSED_PRIVATE_FIELD)
#if(HAS_NO_UNUSED_PRIVATE_FIELD)
#    set(Bam2Bax_CXX_FLAGS "${Bam2Bax_CXX_FLAGS} -Wno-unused-private-field")
#endif()
check_cxx_compiler_flag("-Wno-unused-variable" HAS_NO_UNUSED_VARIABLE)
if(HAS_NO_UNUSED_VARIABLE)
    set(Bam2Bax_CXX_FLAGS "${Bam2Bax_CXX_FLAGS} -Wno-unused-variable")
endif()
check_cxx_compiler_flag("-Wno-uninitialized" HAS_NO_UNINITIALIZED)
if(HAS_NO_UNINITIALIZED)
    set(Bam2Bax_CXX_FLAGS "${Bam2Bax_CXX_FLAGS} -Wno-uninitialized")
endif()
check_cxx_compiler_flag("-Wunused-but-set-variable" HAS_UNUSED_BUT_SET_VARIABLE)
if(HAS_UNUSED_BUT_SET_VARIABLE)
    set(Bam2Bax_CXX_FLAGS "${Bam2Bax_CXX_FLAGS} -Wunused-but-set-variable")
endif()
check_cxx_compiler_flag("-Wno-deprecated-declarations" HAS_NO_DEPRECATED_DECLARATIONS)
if(HAS_NO_DEPRECATED_DECLARATIONS)
    set(Bam2Bax_CXX_FLAGS "${Bam2Bax_CXX_FLAGS} -Wno-deprecated-declarations")
endif()
# NOTE: -Wno-unused-local-typedefs used to quash clang warnings w/ Boost
check_cxx_compiler_flag("-Wno-unused-local-typedef" HAS_NO_UNUSED_LOCAL_TYPEDEF)
if(HAS_NO_UNUSED_LOCAL_TYPEDEF)
    set(Bam2Bax_CXX_FLAGS "${Bam2Bax_CXX_FLAGS} -Wno-unused-local-typedef")
endif()

SET(CMAKE_EXE_LINKER_FLAGS  "${CMAKE_EXE_LINKER_FLAGS} ${Bam2Bax_LINKER_FLAGS}" )

# main exe src
add_subdirectory(src)

# testing
if(Bam2Bax_build_tests)

    enable_testing()
    
    if (NOT GTEST_SRC_DIR)
        set(GTEST_SRC_DIR ../gtest)
    endif()

    add_subdirectory(${GTEST_SRC_DIR} external/gtest/build)
    add_subdirectory(tests)
endif()

=== utils/bax2bam/CMakeLists.txt ===
########################################################################
# CMake build script for Bax2Bam executable.
########################################################################

project(Bax2Bam)
cmake_minimum_required(VERSION 2.8)

# project version
set(Bax2Bam_MAJOR_VERSION 0)
set(Bax2Bam_MINOR_VERSION 0)
set(Bax2Bam_PATCH_VERSION 8)
set(Bax2Bam_VERSION
  "${Bax2Bam_MAJOR_VERSION}.${Bax2Bam_MINOR_VERSION}.${Bax2Bam_PATCH_VERSION}"
)

# build-time options
option(Bax2BAM_build_tests "Build Bax2BAM's unit tests." ON)

# main project paths
set(Bax2Bam_RootDir       ${Bax2Bam_SOURCE_DIR})
set(Bax2Bam_DocsDir       ${Bax2Bam_RootDir}/docs)
set(Bax2Bam_SourceDir     ${Bax2Bam_RootDir}/src)
set(Bax2Bam_TestsDir      ${Bax2Bam_RootDir}/tests)
set(Bax2Bam_ThirdPartyDir ${Bax2Bam_RootDir}/third-party)

if (NOT Bax2BAM_OutputDir)
    set(Bax2BAM_OutputDir ${Bax2Bam_RootDir})
endif()

set(Bax2Bam_BinDir        ${Bax2BAM_OutputDir}/bin)
file(MAKE_DIRECTORY       ${Bax2Bam_BinDir})

# shared & third-party paths
if (NOT PBDATA_ROOT_DIR)
    set(PBDATA_ROOT_DIR ${Bax2Bam_RootDir}/../../../blasr_libcpp)
endif()

# find (existing) libraries needed by executable and tests
if (NOT BLASR_INCLUDE_DIRS OR NOT BLASR_LIBRARIES)
    find_library(BLASR_LIBRARIES    blasr    ${PBDATA_ROOT_DIR}/alignment)
    set(BLASR_INCLUDE_DIRS ${PBDATA_ROOT_DIR}/alignment)
endif()

if (NOT PBIHDF_INCLUDE_DIRS OR NOT PBIHDF_LIBRARIES)
    find_library(PBIHDF_LIBRARIES   pbihdf   ${PBDATA_ROOT_DIR}/hdf)
    set(PBIHDF_INCLUDE_DIRS ${PBDATA_ROOT_DIR}/hdf)
endif()

if (NOT PBDATA_INCLUDE_DIRS OR NOT PBDATA_LIBRARIES)
    find_library(PBDATA_LIBRARIES   pbdata   ${PBDATA_ROOT_DIR}/pbdata)
    set(PBDATA_INCLUDE_DIRS ${PBDATA_ROOT_DIR}/pbdata)
endif()

if (NOT HDF5_INCLUDE_DIRS OR NOT HDF5_LIBRARIES)
    if (NOT HDF5_RootDir)
        set(HDF5_RootDir ${Bax2Bam_RootDir}/../../../../../../prebuilt.out/hdf5/hdf5-1.8.12/ubuntu-1404)
    endif()

    set(HDF5_INCLUDE_DIRS ${HDF5_RootDir}/include)
    set(HDF5_LibDir       ${HDF5_RootDir}/lib)

    find_library(HDF5_LIBRARIES     hdf5     ${HDF5_LibDir} NO_CMAKE_SYSTEM_PATH)
    find_library(HDF5_CPP_LIBRARIES hdf5_cpp ${HDF5_LibDir} NO_CMAKE_SYSTEM_PATH)
endif()

if (NOT PacBioBAM_INCLUDE_DIRS OR NOT PacBioBAM_LIBRARIES
    OR NOT HTSLIB_INCLUDE_DIRS OR NOT HTSLIB_LIBRARIES)
    set(PacBioBAM_RootDir  ${Bax2Bam_RootDir}/../../../../../lib/cpp/pbbam)
    add_subdirectory(${PacBioBAM_RootDir} external/build/pbbam)
endif()

if (NOT Boost_INCLUDE_DIRS)
    find_package(Boost REQUIRED)
endif()

if (NOT ZLIB_LIBRARIES OR NOT ZLIB_INCLUDE_DIRS)
    find_package(ZLIB REQUIRED)
endif()

find_package(Threads)

# shared CXX flags for src & tests
include(CheckCXXCompilerFlag)
set(Bax2Bam_CXX_FLAGS "-g -std=c++11 -Wall")

# quash warnings from pbdata
check_cxx_compiler_flag("-Wno-overloaded-virtual" HAS_NO_OVERLOADED_VIRTUAL)
if(HAS_NO_OVERLOADED_VIRTUAL)
    set(Bax2Bam_CXX_FLAGS "${Bax2Bam_CXX_FLAGS} -Wno-overloaded-virtual")
endif()
#check_cxx_compiler_flag("-Wno-unused-private-field" HAS_NO_UNUSED_PRIVATE_FIELD)
#if(HAS_NO_UNUSED_PRIVATE_FIELD)
#    set(Bax2Bam_CXX_FLAGS "${Bax2Bam_CXX_FLAGS} -Wno-unused-private-field")
#endif()
check_cxx_compiler_flag("-Wno-unused-variable" HAS_NO_UNUSED_VARIABLE)
if(HAS_NO_UNUSED_VARIABLE)
    set(Bax2Bam_CXX_FLAGS "${Bax2Bam_CXX_FLAGS} -Wno-unused-variable")
endif()
check_cxx_compiler_flag("-Wno-uninitialized" HAS_NO_UNINITIALIZED)
if(HAS_NO_UNINITIALIZED)
    set(Bax2Bam_CXX_FLAGS "${Bax2Bam_CXX_FLAGS} -Wno-uninitialized")
endif()
check_cxx_compiler_flag("-Wno-deprecated-declarations" HAS_NO_DEPRECATED_DECLARATIONS)
if(HAS_NO_DEPRECATED_DECLARATIONS)
    set(Bax2Bam_CXX_FLAGS "${Bax2Bam_CXX_FLAGS} -Wno-deprecated-declarations")
endif()
# NOTE: -Wno-unused-local-typedefs used to quash clang warnings w/ Boost
check_cxx_compiler_flag("-Wno-unused-local-typedef" HAS_NO_UNUSED_LOCAL_TYPEDEF)
if(HAS_NO_UNUSED_LOCAL_TYPEDEF)
    set(Bax2Bam_CXX_FLAGS "${Bax2Bam_CXX_FLAGS} -Wno-unused-local-typedef")
endif()

SET(CMAKE_EXE_LINKER_FLAGS  "${CMAKE_EXE_LINKER_FLAGS} ${BAX2BAM_LINKER_FLAGS}" )

# main exe src
add_subdirectory(src)

# testing
if(Bax2BAM_build_tests)

    enable_testing()
    
    if (NOT GTEST_SRC_DIR)
        set(GTEST_SRC_DIR ../gtest)
    endif()

    add_subdirectory(${GTEST_SRC_DIR} external/gtest/build)
    add_subdirectory(tests)
endif()

=== utils/bam2bax/src/CMakeLists.txt ===
include_directories(
    .
    ${BLASR_INCLUDE_DIRS}
    ${Boost_INCLUDE_DIRS}
    ${HDF5_INCLUDE_DIRS}
    ${HTSLIB_INCLUDE_DIRS}
    ${PacBioBAM_INCLUDE_DIRS}
    ${PBDATA_INCLUDE_DIRS}
    ${PBDATA_ROOT_DIR}
    ${PBIHDF_INCLUDE_DIRS}
    ${ZLIB_INCLUDE_DIRS}
)

set(SOURCES
    Settings.h
    Settings.cpp
    Converter.h
    Converter.cpp
    Bam2BaxInternal.h
    RegionTypeAdapter.h
    RegionsAdapter.h
    Bam2BaxConverter.h
    Bam2BaxConverterImpl.hpp
    Bam2Bax.h
    Bam2Bax.cpp
    OptionParser.h
    OptionParser.cpp
    MetadataWriter.h
    MetadataWriter.cpp
)

set(BAM2BAX_SOURCES
    Bam2BaxMain.cpp
    ${SOURCES}
)

set(BAM2PLX_SOURCES
    Bam2PlxMain.cpp
    ${SOURCES}
)

set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${Bam2Bax_CXX_FLAGS}")
set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} ${Bam2Bax_EXE_LINKER_FLAGS}")

add_executable(bam2bax ${BAM2BAX_SOURCES})
set_target_properties(bam2bax PROPERTIES
    RUNTIME_OUTPUT_DIRECTORY ${Bam2Bax_BinDir}
)
if (NOT APPLE)
    set(MY_LIBRT -lrt)
else()
endif()
target_link_libraries(bam2bax
    ${BLASR_LIBRARIES}
    ${PBIHDF_LIBRARIES}
    ${PBDATA_LIBRARIES}
    ${HDF5_CPP_LIBRARIES}
    ${HDF5_LIBRARIES}
    ${PacBioBAM_LIBRARIES}
    ${HTSLIB_LIBRARIES}
    ${ZLIB_LIBRARIES}
    ${MY_LIBRT}
)

add_executable(bam2plx ${BAM2PLX_SOURCES} )
set_target_properties(bam2plx PROPERTIES
    RUNTIME_OUTPUT_DIRECTORY ${Bam2Bax_BinDir}
)
target_link_libraries(bam2plx
    ${BLASR_LIBRARIES}
    ${PBIHDF_LIBRARIES}
    ${PBDATA_LIBRARIES}
    ${HDF5_CPP_LIBRARIES}
    ${HDF5_LIBRARIES}
    ${PacBioBAM_LIBRARIES}
    ${HTSLIB_LIBRARIES}
    ${ZLIB_LIBRARIES}
    ${MY_LIBRT}
)

=== utils/bam2bax/tests/CMakeLists.txt ===
file(MAKE_DIRECTORY ${Bam2Bax_TestsDir}/bin)
file(MAKE_DIRECTORY ${Bam2Bax_TestsDir}/out)

# Generate path for test data
configure_file(
    ${Bam2Bax_TestsDir}/src/TestData.h.in
    ${Bam2Bax_TestsDir}/src/TestData.h
)

include(files.cmake)
include_directories(
    ${Bam2Bax_SourceDir}
    ${BLASR_INCLUDE_DIRS}
    ${Boost_INCLUDE_DIRS}
    ${HDF5_INCLUDE_DIRS}
    ${HTSLIB_INCLUDE_DIRS}
    ${PacBioBAM_INCLUDE_DIRS}
    ${PBDATA_INCLUDE_DIRS}
    ${PBDATA_ROOT_DIR}
    ${PBIHDF_INCLUDE_DIRS}
    ${ZLIB_INCLUDE_DIRS}
    ${gtest_SOURCE_DIR}/include
    ${gtest_SOURCE_DIR}
)

set(SOURCES
    ${Bam2BaxTest_H}
    ${Bam2BaxTest_CPP}
)

# shared CXX flags for src & tests
include(CheckCXXCompilerFlag)
set(Bam2Bax_CXX_FLAGS "-g -std=c++11 -Wall")

# quash warnings from pbdata
check_cxx_compiler_flag("-Wno-overloaded-virtual" HAS_NO_OVERLOADED_VIRTUAL)
if(HAS_NO_OVERLOADED_VIRTUAL)
    set(Bam2Bax_CXX_FLAGS "${Bam2Bax_CXX_FLAGS} -Wno-overloaded-virtual")
endif()
check_cxx_compiler_flag("-Wno-unused-private-field" HAS_NO_UNUSED_PRIVATE_FIELD)
if(HAS_NO_UNUSED_PRIVATE_FIELD)
    set(Bam2Bax_CXX_FLAGS "${Bam2Bax_CXX_FLAGS} -Wno-unused-private-field")
endif()
check_cxx_compiler_flag("-Wno-unused-variable" HAS_NO_UNUSED_VARIABLE)
if(HAS_NO_UNUSED_VARIABLE)
    set(Bam2Bax_CXX_FLAGS "${Bam2Bax_CXX_FLAGS} -Wno-unused-variable")
endif()
check_cxx_compiler_flag("-Wno-uninitialized" HAS_NO_UNINITIALIZED)
if(HAS_NO_UNINITIALIZED)
    set(Bam2Bax_CXX_FLAGS "${Bam2Bax_CXX_FLAGS} -Wno-uninitialized")
endif()
check_cxx_compiler_flag("-Wunused-but-set-variable" HAS_UNUSED_BUT_SET_VARIABLE)
if(HAS_UNUSED_BUT_SET_VARIABLE)
    set(Bam2Bax_CXX_FLAGS "${Bam2Bax_CXX_FLAGS} -Wunused-but-set-variable")
endif()
# NOTE: -Wno-unused-local-typedefs used to quash clang warnings w/ Boost
check_cxx_compiler_flag("-Wno-unused-local-typedef" HAS_NO_UNUSED_LOCAL_TYPEDEF)
if(HAS_NO_UNUSED_LOCAL_TYPEDEF)
    set(Bam2Bax_CXX_FLAGS "${Bam2Bax_CXX_FLAGS} -Wno-unused-local-typedef")
endif()

set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${Bam2Bax_CXX_FLAGS}")
set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} ${Bam2Bax_EXE_LINKER_FLAGS}")

add_executable(test_bam2bax ${SOURCES})

set_target_properties(test_bam2bax PROPERTIES
    RUNTIME_OUTPUT_DIRECTORY ${Bam2Bax_TestsDir}/bin
)
if (NOT APPLE)
    set(MY_LIBRT -lrt)
else()
endif()
target_link_libraries(test_bam2bax
    gtest
    gtest_main
    ${BLASR_LIBRARIES}
    ${PBIHDF_LIBRARIES}
    ${PBDATA_LIBRARIES}
    ${HDF5_CPP_LIBRARIES}
    ${HDF5_LIBRARIES}
    ${PacBioBAM_LIBRARIES}
    ${HTSLIB_LIBRARIES}
    ${ZLIB_LIBRARIES}
    ${CMAKE_THREAD_LIBS_INIT} # quirky pthreads
    ${MY_LIBRT}
)

add_test(
    NAME UnitTests 
    WORKING_DIRECTORY ${Bam2Bax_TestsDir}/bin
    COMMAND test_bam2bax 
)

=== utils/bax2bam/src/CMakeLists.txt ===
include_directories(
    .
    ${BLASR_INCLUDE_DIRS}
    ${Boost_INCLUDE_DIRS}
    ${HDF5_INCLUDE_DIRS}
    ${HTSLIB_INCLUDE_DIRS}
    ${PacBioBAM_INCLUDE_DIRS}
    ${PBDATA_INCLUDE_DIRS}
    ${PBDATA_ROOT_DIR}
    ${PBIHDF_INCLUDE_DIRS}
    ${ZLIB_INCLUDE_DIRS}
)

set(SOURCES
    main.cpp
    Bax2Bam.h
    Bax2Bam.cpp
    CcsConverter.h
    CcsConverter.cpp
    ConverterBase.h
    HqRegionConverter.h
    HqRegionConverter.cpp
    IConverter.h
    IConverter.cpp
    OptionParser.h
    OptionParser.cpp
    PolymeraseReadConverter.h
    PolymeraseReadConverter.cpp
    Settings.h
    Settings.cpp
    SubreadConverter.h
    SubreadConverter.cpp
)

set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${Bax2Bam_CXX_FLAGS}")
set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} ${Bax2Bam_EXE_LINKER_FLAGS}")


add_executable(bax2bam ${SOURCES})
set_target_properties(bax2bam PROPERTIES
    RUNTIME_OUTPUT_DIRECTORY ${Bax2Bam_BinDir}
)
if (NOT APPLE)
    set(MY_LIBRT -lrt)
else()
endif()
target_link_libraries(bax2bam 
    ${BLASR_LIBRARIES}
    ${PBIHDF_LIBRARIES}
    ${PBDATA_LIBRARIES} 
    ${HDF5_CPP_LIBRARIES}
    ${HDF5_LIBRARIES}
    ${PacBioBAM_LIBRARIES}
    ${HTSLIB_LIBRARIES}
    ${ZLIB_LIBRARIES}
    ${CMAKE_THREAD_LIBS_INIT}
    ${MY_LIBRT}
    "-ldl"
)

=== utils/bax2bam/tests/CMakeLists.txt ===
file(MAKE_DIRECTORY  ${Bax2Bam_TestsDir}/bin)

# Generate paths for test data
configure_file(
    ${Bax2Bam_TestsDir}/src/TestData.h.in
    ${Bax2Bam_TestsDir}/src/TestData.h
)
include(files.cmake)
include_directories(
    ${BLASR_INCLUDE_DIRS}
    ${Boost_INCLUDE_DIRS}
    ${HDF5_INCLUDE_DIRS}
    ${HTSLIB_INCLUDE_DIRS}
    ${PacBioBAM_INCLUDE_DIRS}
    ${PBDATA_INCLUDE_DIRS}
    ${PBDATA_ROOT_DIR}
    ${PBIHDF_INCLUDE_DIRS}
    ${ZLIB_INCLUDE_DIRS}
    ${gtest_SOURCE_DIR}/include 
    ${gtest_SOURCE_DIR}
#    ${Bax2BamTest_H}
)

# Grab postprimary test source files

set(SOURCES
    ${Bax2BamTest_H}
    ${Bax2BamTest_CPP}
)

# shared CXX flags for src & tests
include(CheckCXXCompilerFlag)
set(Bax2Bam_CXX_FLAGS "-g -std=c++11 -Wall")

# quash warnings from pbdata
check_cxx_compiler_flag("-Wno-overloaded-virtual" HAS_NO_OVERLOADED_VIRTUAL)
if(HAS_NO_OVERLOADED_VIRTUAL)
    set(Bax2Bam_CXX_FLAGS "${Bax2Bam_CXX_FLAGS} -Wno-overloaded-virtual")
endif()
check_cxx_compiler_flag("-Wno-unused-private-field" HAS_NO_UNUSED_PRIVATE_FIELD)
if(HAS_NO_UNUSED_PRIVATE_FIELD)
    set(Bax2Bam_CXX_FLAGS "${Bax2Bam_CXX_FLAGS} -Wno-unused-private-field")
endif()
check_cxx_compiler_flag("-Wno-unused-variable" HAS_NO_UNUSED_VARIABLE)
if(HAS_NO_UNUSED_VARIABLE)
    set(Bax2Bam_CXX_FLAGS "${Bax2Bam_CXX_FLAGS} -Wno-unused-variable")
endif()
check_cxx_compiler_flag("-Wno-uninitialized" HAS_NO_UNINITIALIZED)
if(HAS_NO_UNINITIALIZED)
    set(Bax2Bam_CXX_FLAGS "${Bax2Bam_CXX_FLAGS} -Wno-uninitialized")
endif()
# NOTE: -Wno-unused-local-typedefs used to quash clang warnings w/ Boost
check_cxx_compiler_flag("-Wno-unused-local-typedef" HAS_NO_UNUSED_LOCAL_TYPEDEF)
if(HAS_NO_UNUSED_LOCAL_TYPEDEF)
    set(Bam2Bax_CXX_FLAGS "${Bax2Bam_CXX_FLAGS} -Wno-unused-local-typedef")
endif()
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${Bax2Bam_CXX_FLAGS}")
set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} ${Bax2Bam_EXE_LINKER_FLAGS}")

add_executable(test_bax2bam ${SOURCES})
# add_executable(test_bax2bam ${Bax2Bam_TestsDir}/src/test_ccs.cpp)
set_target_properties(test_bax2bam PROPERTIES
    RUNTIME_OUTPUT_DIRECTORY ${Bax2Bam_TestsDir}/bin
)
if (NOT APPLE)
    set(MY_LIBRT -lrt)
else()
endif()
target_link_libraries(test_bax2bam
    gtest
    gtest_main
    ${BLASR_LIBRARIES}
    ${PBIHDF_LIBRARIES}
    ${PBDATA_LIBRARIES} 
    ${HDF5_CPP_LIBRARIES}
    ${HDF5_LIBRARIES}
    ${PacBioBAM_LIBRARIES}
    ${HTSLIB_LIBRARIES}
    ${ZLIB_LIBRARIES}
    ${CMAKE_THREAD_LIBS_INIT} # quirky pthreads
    ${MY_LIBRT}
    "-ldl"
)
# add_test(test_bax2bam test_bax2bam)
add_test(
    NAME UnitTests
    WORKING_DIRECTORY ${Bax2Bam_TestsDir}/bin
    COMMAND test_bax2bam
)

## blasr 5.3+0

=== utils/bam2bax/CMakeLists.txt ===
--- 
+++ 
@@ -66,8 +66,15 @@
 
 if (NOT PacBioBAM_INCLUDE_DIRS OR NOT PacBioBAM_LIBRARIES
     OR NOT HTSLIB_INCLUDE_DIRS OR NOT HTSLIB_LIBRARIES)
-    set(PacBioBAM_RootDir ${Bam2Bax_RootDir}/../../../../../lib/cpp/pbbam)
+    set(PacBioBAM_LIBRARIES )
+    set(PacBioBAM_INCLUDE_DIRS )
+    set(HTSLIB_INCLUDE_DIRS )
+    set(HTSLIB_LIBRARIES )
+    if (NOT PacBioBAM_RootDir)
+        message ("Must either set (PacBioBAM_INCLUDE_DIRS, PacBioBAM_LIBRARIES, HTSLIB_INCLUDE_DIRS, and HTSLIB_LIBRARIES) or PacBioBAM_RootDir!")
+    endif()
     add_subdirectory(${PacBioBAM_RootDir} external/build/pbbam)
+    set(PBBAM_LINK_FLAG pbbam)
 endif()
 
 if (NOT Boost_INCLUDE_DIRS)
@@ -130,4 +137,3 @@
     add_subdirectory(${GTEST_SRC_DIR} external/gtest/build)
     add_subdirectory(tests)
 endif()
-

=== utils/bax2bam/CMakeLists.txt ===
--- 
+++ 
@@ -65,8 +65,15 @@
 
 if (NOT PacBioBAM_INCLUDE_DIRS OR NOT PacBioBAM_LIBRARIES
     OR NOT HTSLIB_INCLUDE_DIRS OR NOT HTSLIB_LIBRARIES)
-    set(PacBioBAM_RootDir  ${Bax2Bam_RootDir}/../../../../../lib/cpp/pbbam)
+    set(PacBioBAM_INCLUDE_DIRS )
+    set(PacBioBAM_LIBRARIES )
+    set(HTSLIB_INCLUDE_DIRS )
+    set(HTSLIB_LIBRARIES )
+    if (NOT PacBioBAM_RootDir)
+        message ("Must either set (PacBioBAM_INCLUDE_DIRS, PacBioBAM_LIBRARIES, HTSLIB_INCLUDE_DIRS, and HTSLIB_LIBRARIES) or PacBioBAM_RootDir!")
+    endif()
     add_subdirectory(${PacBioBAM_RootDir} external/build/pbbam)
+    set(PBBAM_LINK_FLAG pbbam)
 endif()
 
 if (NOT Boost_INCLUDE_DIRS)

=== utils/bam2bax/src/CMakeLists.txt ===
--- 
+++ 
@@ -51,6 +51,7 @@
 else()
 endif()
 target_link_libraries(bam2bax
+    ${PBBAM_LINK_FLAG}
     ${BLASR_LIBRARIES}
     ${PBIHDF_LIBRARIES}
     ${PBDATA_LIBRARIES}
@@ -67,6 +68,7 @@
     RUNTIME_OUTPUT_DIRECTORY ${Bam2Bax_BinDir}
 )
 target_link_libraries(bam2plx
+    ${PBBAM_LINK_FLAG}
     ${BLASR_LIBRARIES}
     ${PBIHDF_LIBRARIES}
     ${PBDATA_LIBRARIES}

=== utils/bam2bax/tests/CMakeLists.txt ===
--- 
+++ 
@@ -74,6 +74,7 @@
 target_link_libraries(test_bam2bax
     gtest
     gtest_main
+    ${PBBAM_LINK_FLAG}
     ${BLASR_LIBRARIES}
     ${PBIHDF_LIBRARIES}
     ${PBDATA_LIBRARIES}

=== utils/bax2bam/src/CMakeLists.txt ===
--- 
+++ 
@@ -45,6 +45,7 @@
 else()
 endif()
 target_link_libraries(bax2bam 
+    ${PBBAM_LINK_FLAG}
     ${BLASR_LIBRARIES}
     ${PBIHDF_LIBRARIES}
     ${PBDATA_LIBRARIES}

=== utils/bax2bam/tests/CMakeLists.txt ===
--- 
+++ 
@@ -69,6 +69,7 @@
 target_link_libraries(test_bax2bam
     gtest
     gtest_main
+    ${PBBAM_LINK_FLAG}
     ${BLASR_LIBRARIES}
     ${PBIHDF_LIBRARIES}
     ${PBDATA_LIBRARIES}

=== debian/changelog ===
blasr (5.3+0-2) unstable; urgency=low

  * Team upload

  [ Steffen Moeller ]
  * debian/upstream/metadata: Added references to OMICtools and RRID

  [ Afif Elghraoui ]
  * Add README.source

  [ Gilles Filippini ]
  * Support for HDF5 1.10.1
    Closes: #892630

  [ Andreas Tille ]
  * d/control:
     - more cme-ish sequence of entries
     - Standards-Version: 4.1.3
  * debhelper 11

 -- Andreas Tille <tille@debian.org>  Sun, 11 Mar 2018 18:02:22 +0100

blasr (5.3+0-1) unstable; urgency=medium

  * Imported Upstream version 5.3+0 (corresponds to smrtanalysis-4.0.0 tag)
  * Refresh patches

 -- Afif Elghraoui <afif@debian.org>  Fri, 23 Dec 2016 17:50:11 -0800

blasr (5.3-2) unstable; urgency=medium

  * Use pbseqlib metapackage rather than depending on individual libraries
  * Build with pbbam (Closes: #848751, #848541)
  * Build bax2bam and bam2bax

 -- Afif Elghraoui <afif@debian.org>  Tue, 20 Dec 2016 02:02:51 -0800

blasr (5.3-1) unstable; urgency=medium

  * Imported Upstream version 5.3
    (upstream git revision 1baabc8 from 2016-09-12)
  * Find PB libraries in the default LD path
  * Bump Standards-Version to 3.9.8
  * Use encrypted protocols for VCS
  * Update email address and copyright year
  * Update paths to pbseqlib headers
  * Remove unused lintian overrides
  * Update debian/TODO
  * Add d/NEWS to explain interface change
  * d/rules: Minor clean-ups

 -- Afif Elghraoui <afif@debian.org>  Sun, 23 Oct 2016 18:21:55 -0700

=== debian/control ===
Source: blasr
Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders: Afif Elghraoui <afif@debian.org>
Section: science
Priority: optional
Build-Depends:
	debhelper (>= 11~),
	python,
	cmake,
	libboost-dev,
	libhdf5-dev,
	zlib1g-dev,
	libpbseq-dev (>= 0~20160912),
	libpbbam-dev,
Standards-Version: 4.1.3
Vcs-Browser: https://anonscm.debian.org/cgit/debian-med/blasr.git
Vcs-Git: https://anonscm.debian.org/git/debian-med/blasr.git
Homepage: https://github.com/PacificBiosciences/blasr

Package: blasr
Architecture: any
Depends:
	${shlibs:Depends},
	${misc:Depends},
	libpbseq (>= 0~20160912),
	libpbbam,
Description: mapping single-molecule sequencing reads
 Basic local alignment with successive refinement (BLASR) is a method
 for mapping single-molecule sequencing reads against a reference genome.
 Such reads are thousands of bases long, with divergence between them
 and the genome being dominated by insertion and deletion error.

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/default.mk

export VERBOSE=1 # for cmake
export SH_LIB_EXT=.so

export HDF5_INC=/usr/include/hdf5/serial
export HDF5_LIB=/usr/lib/$(DEB_HOST_MULTIARCH)/hdf5/serial
export BOOST_INC=/usr/include/boost
export HTSLIB_INC=/usr/include/htslib
export HTSLIB_LIB=/usr/lib/$(DEB_HOST_MULTIARCH)
export PBBAM_INC=/usr/include
export PBBAM_LIB=/usr/lib/$(DEB_HOST_MULTIARCH)
export PBDATA_ROOT_DIR=/usr/include/pbseq
export LIBBLASR_INC=$(PBDATA_ROOT_DIR)/alignment
export LIBBLASR_LIB=/usr/lib/$(DEB_HOST_MULTIARCH)
export LIBPBDATA_INC=$(PBDATA_ROOT_DIR)/pbdata
export LIBPBDATA_LIB=/usr/lib/$(DEB_HOST_MULTIARCH)
export LIBPBIHDF_INC=$(PBDATA_ROOT_DIR)/hdf
export LIBPBIHDF_LIB=/usr/lib/$(DEB_HOST_MULTIARCH)

# Needed for HDF5 1.10.1 support
HDF5_VERSION := $(shell grep 'HDF5 Version' $(HDF5_LIB)/libhdf5.settings | awk '{print $$3}')
ifeq (yes,$(shell dpkg --compare-versions $(HDF5_VERSION) '>=' 1.10.1 && echo yes))
export DEB_CXXFLAGS_MAINT_APPEND=-DHAVE_HDF5_1_10_1
endif

# CPPFLAGS apparently aren't exported for bam2bax/bax2bam
export DEB_CXXFLAGS_MAINT_PREPEND = $(CPPFLAGS) -I$(PBDATA_ROOT_DIR)

%:
	dh $@

override_dh_auto_configure:
	./configure.py --shared

override_dh_auto_build: main bax2bam bam2bax;

.PHONY: main
main:
	dh_auto_build

.PHONY: bax2bam
bax2bam: utils/bax2bax/bin/bax2bam
utils/bax2bax/bin/bax2bam:
	$(MAKE) -C utils/bax2bam

.PHONY: bam2bax
bam2bax: utils/bam2bax/bin/bam2bax
utils/bam2bax/bin/bam2bax:
	$(MAKE) -C utils/bam2bax

# Tests require data not available in the source distribution
override_dh_auto_test: ;

override_dh_auto_clean: override_dh_auto_configure
	$(MAKE) clean
	$(MAKE) -C utils/bam2bax clean
	$(MAKE) -C utils/bax2bam clean
	# This is created by configure.py
	$(RM) defines.mk

## blasr 5.3.2+dfsg

=== debian/changelog ===
blasr (5.3.2+dfsg-1.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Remove manual dependency on libpbbam, a proper one is already
    being generated.

 -- Adrian Bunk <bunk@debian.org>  Wed, 06 Feb 2019 09:24:24 +0200

blasr (5.3.2+dfsg-1) unstable; urgency=medium

  * Team upload

  [ Andreas Tille ]
  * New upstream version
  * Build-Depends: libpbdata-dev
    Closes: #906811
  * d/watch: point to Github since upstream is now tagging releases
  * Point Vcs fields to salsa.debian.org
  * debhelper 12
  * Standards-Version: 4.3.0
  * Build system switched from cmake to meson
  * Versioned Build-Depends: libblasr-dev
  * Cleanup d/rules
  * Update manpages
  * Mention tools that are not build an more in NEWS.Debian

  [ Jelmer Vernooĳ ]
  * Use secure copyright file specification URI.

 -- Andreas Tille <tille@debian.org>  Mon, 28 Jan 2019 16:10:36 +0100

=== debian/control ===
Source: blasr
Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders: Afif Elghraoui <afif@debian.org>
Section: science
Priority: optional
Build-Depends: debhelper (>= 12~),
               python,
               meson,
               pkg-config,
               libboost-dev,
               libhdf5-dev,
               zlib1g-dev,
               libpbseq-dev (>= 0~20160912),
               libpbbam-dev (>= 0.18.0~),
               libpbdata-dev,
               libgtest-dev,
               libblasr-dev (>= 5.3.1+dfsg-2)
Standards-Version: 4.3.0
Vcs-Browser: https://salsa.debian.org/med-team/blasr
Vcs-Git: https://salsa.debian.org/med-team/blasr.git
Homepage: https://github.com/PacificBiosciences/blasr

Package: blasr
Architecture: any
Depends: ${shlibs:Depends},
         ${misc:Depends},
         libpbseq (>= 0~20160912)
Description: mapping single-molecule sequencing reads
 Basic local alignment with successive refinement (BLASR) is a method
 for mapping single-molecule sequencing reads against a reference genome.
 Such reads are thousands of bases long, with divergence between them
 and the genome being dominated by insertion and deletion error.

=== debian/rules ===
--- 
+++ 
@@ -30,33 +30,24 @@
 export DEB_CXXFLAGS_MAINT_PREPEND = $(CPPFLAGS) -I$(PBDATA_ROOT_DIR)
 
 %:
-	dh $@
+	dh $@ --buildsystem=meson
 
 override_dh_auto_configure:
-	./configure.py --shared
+	LDFLAGS="-L$(HTSLIB_LIB) -L$(HDF5_LIB) -lhdf5_cpp -lhdf5" CPPFLAGS="-isystem $(HDF5_INC)" meson -Dtests=false -Dprefix=/usr build .
 
-override_dh_auto_build: main bax2bam bam2bax;
-
-.PHONY: main
-main:
-	dh_auto_build
-
-.PHONY: bax2bam
 bax2bam: utils/bax2bax/bin/bax2bam
 utils/bax2bax/bin/bax2bam:
 	$(MAKE) -C utils/bax2bam
 
-.PHONY: bam2bax
 bam2bax: utils/bam2bax/bin/bam2bax
 utils/bam2bax/bin/bam2bax:
 	$(MAKE) -C utils/bam2bax
 
-# Tests require data not available in the source distribution
-override_dh_auto_test: ;
+ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
+override_dh_auto_test:
+	echo Tests require data not available in the source distribution
+endif
 
-override_dh_auto_clean: override_dh_auto_configure
-	$(MAKE) clean
-	$(MAKE) -C utils/bam2bax clean
-	$(MAKE) -C utils/bax2bam clean
-	# This is created by configure.py
-	$(RM) defines.mk
+override_dh_auto_build:
+	ln -s build obj-$(DEB_BUILD_GNU_TYPE)
+	dh_auto_build

## blasr 5.3.3+dfsg

=== meson_options.txt ===
option('tests',
    type : 'boolean',
    value : true,
    description : 'Enable dependencies required for testing')

=== debian/changelog ===
blasr (5.3.3+dfsg-5) unstable; urgency=medium

  * debhelper-compat 13 (routine-update)
  * Add salsa-ci file (routine-update)
  * Rules-Requires-Root: no (routine-update)
  * Set upstream metadata fields: Repository, Repository-Browse.
  * Versioned Build-Depends: libblasr-dev (>= 5.3.4+dfsg-3~) since other
    Debian releases put header file on wrong location

 -- Andreas Tille <tille@debian.org>  Mon, 16 Nov 2020 13:51:01 +0100

blasr (5.3.3+dfsg-4) unstable; urgency=medium

  * Standards-Version: 4.5.0
  * Versioned Build-Depends: libblasr-dev (>= 5.3.3+dfsg-2)
    Closes: #949543

 -- Andreas Tille <tille@debian.org>  Wed, 22 Jan 2020 17:48:33 +0100

blasr (5.3.3+dfsg-3) unstable; urgency=medium

  * Build-Depends: s/python/python3/
  * Standards-Version: 4.4.1
  * Build-Depends: cmake
  * Do not check for pbbam with meson - its ensured by Build-Depends
  * Build-Depends: libpbcopper-dev
  * Fix meson depencencies
    Closes: #948926
  * rename debian/NEWS.Debian to debian/NEWS

 -- Andreas Tille <tille@debian.org>  Thu, 16 Jan 2020 08:54:12 +0100

blasr (5.3.3+dfsg-2) unstable; urgency=medium

  * Use 2to3 to port to Python3
    Closes: #936213

 -- Andreas Tille <tille@debian.org>  Sun, 01 Sep 2019 07:52:40 +0200

blasr (5.3.3+dfsg-1) unstable; urgency=medium

  * Afif removed himself from Uploaders (thanks for your work on this)
  * Add myself to Uploaders
  * New upstream version
  * debhelper-compat 12
  * Standards-Version: 4.4.0

 -- Andreas Tille <tille@debian.org>  Wed, 31 Jul 2019 14:55:41 +0200

=== debian/control ===
Source: blasr
Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders: Andreas Tille <tille@debian.org>
Section: science
Priority: optional
Build-Depends: debhelper-compat (= 13),
               python3,
               meson,
               cmake,
               pkg-config,
               libboost-dev,
               libhdf5-dev,
               zlib1g-dev,
               libpbseq-dev,
               libpbbam-dev (>= 0.18.0~),
               libpbdata-dev,
               libpbcopper-dev,
               libgtest-dev,
               libblasr-dev (>= 5.3.4+dfsg-3~)
Standards-Version: 4.5.0
Vcs-Browser: https://salsa.debian.org/med-team/blasr
Vcs-Git: https://salsa.debian.org/med-team/blasr.git
Homepage: https://github.com/PacificBiosciences/blasr
Rules-Requires-Root: no

Package: blasr
Architecture: any
Depends: ${shlibs:Depends},
         ${misc:Depends},
         libpbseq
Description: mapping single-molecule sequencing reads
 Basic local alignment with successive refinement (BLASR) is a method
 for mapping single-molecule sequencing reads against a reference genome.
 Such reads are thousands of bases long, with divergence between them
 and the genome being dominated by insertion and deletion error.

=== debian/rules ===
--- 
+++ 
@@ -23,7 +23,7 @@
 # Needed for HDF5 1.10.1 support
 HDF5_VERSION := $(shell grep 'HDF5 Version' $(HDF5_LIB)/libhdf5.settings | awk '{print $$3}')
 ifeq (yes,$(shell dpkg --compare-versions $(HDF5_VERSION) '>=' 1.10.1 && echo yes))
-export DEB_CXXFLAGS_MAINT_APPEND=-DHAVE_HDF5_1_10_1
+export DEB_CXXFLAGS_MAINT_APPEND=-DHAVE_HDF5_1_10_1 -std=c++14
 endif
 
 # CPPFLAGS apparently aren't exported for bam2bax/bax2bam

=== debian/watch ===
version=4

opts="repacksuffix=+dfsg,dversionmangle=auto,repack,compression=xz" \
  https://github.com/PacificBiosciences/blasr/releases .*/archive/v?@ANY_VERSION@@ARCHIVE_EXT@
